#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

struct Node {
    size_t currSucc;
    size_t pred;
    vector<size_t> successors;

    Node () = default;
};

Node* nodes;

size_t rec (size_t index) {
    if (nodes[index].successors.empty()) {
        return index;
    }

    size_t res = rec (nodes[index].successors[nodes[index].currSucc]);
    nodes[index].currSucc++;
    if (nodes[index].currSucc >= nodes[index].successors.size()) {
        nodes[index].currSucc = 0;
    }

    return res;
}

size_t getCycle (size_t index) {
    if (nodes[index].successors.empty ()) {
        return 1;
    }
    size_t cycle = 1;
    for (size_t succIndex : nodes[index].successors) {
        if (nodes[succIndex].successors.empty()) {
            cycle += getCycle(succIndex);
        } else {
            cycle *= getCycle(succIndex);
        }
    }

    return cycle;
}

int main() {
    size_t nodeCount, breadCount;

    cin >> nodeCount >> breadCount;

    nodes = new Node [nodeCount] ();

    for (size_t i = 1; i < nodeCount; i++) {

        cin >> nodes[i].pred;
        nodes[nodes[i].pred].successors.push_back (i);
    }

    size_t cycle = getCycle(0);

    size_t* cycleBehav = new size_t[cycle];

    for (size_t i = 0; i < cycle; i++) {
        cycleBehav[i] = rec (0);
    }

    for (size_t i = 0; i < breadCount; i++) {
        cout << cycleBehav[i % cycle] << endl;
    }

    return 0;
}
